#include "opencv2/opencv.hpp"
#include "opencv2/videoio.hpp"
#include "opencv2/imgproc.hpp"
#include "opencv2/highgui.hpp"
#include <fstream>
#include "ImageProcessing.h"
#include "TrajectoryComputation.h"
# define LengthFishPixel    75.0 // Define length of the larva in pixel:
# define SizeMax    12000 // Define length of vector containing trajectories
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>
using namespace std;
using namespace cv;



std::ofstream file;


int main(int, char**)
{
    glutInitWindowPosition(10, 10);
	glutInitWindowSize(1024,768);
	// Type d'affichage
	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE );
	// Affichage de la fen\EAtre
	glutCreateWindow("Grid");
    file.open("TailDeflection.txt"); // File Containing Tail Deflection index

    Trajectory trajectory[SizeMax]; // Structure to store trajectory for 2h

    VideoCapture cap("MovieLarva.avi"); // open the high Speed Camera or an avi
    if(!cap.isOpened())  // check if we succeeded
        return -1;
    Mat img;
    namedWindow("Larva",1);
    int j=0;
    for(;;)
    {
        // Compute Tail Deflection
        Mat frame;
        cap >> frame; // get a new frame from camera
        cvtColor(frame, img, CV_BGR2GRAY);
        GaussianBlur(img, img, Size(7,7), 0.5, 0.5);
        threshold(img,img,220,255,CV_THRESH_BINARY_INV );
        imshow("Larva", img);
        if(waitKey(100) >= 0) break; // Replace 100 by 5 to increase the speed
        cout <<ComputeTailDeflection(img)<<endl;
        file <<j<<","<<ComputeTailDeflection(img)<<endl;
        j++;
    }
    return 0;
}

